'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _virtex = require('virtex');

var _stringifyAttrs = require('@f/stringify-attrs');

var _stringifyAttrs2 = _interopRequireDefault(_stringifyAttrs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Actions
 */

/**
 * Imports
 */

var CREATE_NODE = _virtex.actions.types.CREATE_NODE;

/**
 * Virtex string
 */

function string() {
  return function (next) {
    return function (action) {
      if (action.type === CREATE_NODE) {
        var vnode = action.vnode;
        var children = action.children;

        vnode.element = render(vnode, children);
        return vnode;
      }

      return next(action);
    };
  };
}

function render(_ref, children) {
  var type = _ref.type;
  var props = _ref.props;

  return type === '#text' ? props.nodeValue : stringifyElement(type, props, children.reduce(function (acc, child) {
    return acc + child.element;
  }, ''));
}

function stringifyElement(tag, attrs, contents) {
  return '<' + tag + (0, _stringifyAttrs2.default)(attrs) + '>' + contents + '</' + tag + '>';
}

/**
 * Exports
 */

exports.default = string;